<?php
/**
 * CalculationDelivery
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Logistic
 *
 * Управление логистикой
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\LogisticClient\Dto;

use \ArrayAccess;
use \Ensi\LogisticClient\ObjectSerializer;

/**
 * CalculationDelivery Class Doc Comment
 *
 * @category Class
 * @package  Ensi\LogisticClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class CalculationDelivery implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'CalculationDelivery';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'delivery_service' => 'int',
        'dt' => 'int',
        'pdd' => '\DateTime',
        'shipments' => '\Ensi\LogisticClient\Dto\CalculationShipment[]',
        'tariffs' => '\Ensi\LogisticClient\Dto\CalculationTariff[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'delivery_service' => null,
        'dt' => null,
        'pdd' => 'date',
        'shipments' => null,
        'tariffs' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'delivery_service' => false,
        'dt' => false,
        'pdd' => false,
        'shipments' => false,
        'tariffs' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'delivery_service' => 'delivery_service',
        'dt' => 'dt',
        'pdd' => 'pdd',
        'shipments' => 'shipments',
        'tariffs' => 'tariffs'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'delivery_service' => 'setDeliveryService',
        'dt' => 'setDt',
        'pdd' => 'setPdd',
        'shipments' => 'setShipments',
        'tariffs' => 'setTariffs'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'delivery_service' => 'getDeliveryService',
        'dt' => 'getDt',
        'pdd' => 'getPdd',
        'shipments' => 'getShipments',
        'tariffs' => 'getTariffs'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('delivery_service', $data, null);
        $this->setIfExists('dt', $data, null);
        $this->setIfExists('pdd', $data, null);
        $this->setIfExists('shipments', $data, null);
        $this->setIfExists('tariffs', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['delivery_service'] === null) {
            $invalidProperties[] = "'delivery_service' can't be null";
        }
        if ($this->container['dt'] === null) {
            $invalidProperties[] = "'dt' can't be null";
        }
        if ($this->container['pdd'] === null) {
            $invalidProperties[] = "'pdd' can't be null";
        }
        if ($this->container['shipments'] === null) {
            $invalidProperties[] = "'shipments' can't be null";
        }
        if ($this->container['tariffs'] === null) {
            $invalidProperties[] = "'tariffs' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets delivery_service
     *
     * @return int
     */
    public function getDeliveryService()
    {
        return $this->container['delivery_service'];
    }

    /**
     * Sets delivery_service
     *
     * @param int $delivery_service delivery_service
     *
     * @return $this
     */
    public function setDeliveryService($delivery_service)
    {


        /*if (is_null($delivery_service)) {
            throw new \InvalidArgumentException('non-nullable delivery_service cannot be null');
        }*/
        $this->container['delivery_service'] = $delivery_service;

        return $this;
    }

    /**
     * Gets dt
     *
     * @return int
     */
    public function getDt()
    {
        return $this->container['dt'];
    }

    /**
     * Sets dt
     *
     * @param int $dt Delivery Time - время доставки в днях, которое отдаёт ЛО
     *
     * @return $this
     */
    public function setDt($dt)
    {


        /*if (is_null($dt)) {
            throw new \InvalidArgumentException('non-nullable dt cannot be null');
        }*/
        $this->container['dt'] = $dt;

        return $this;
    }

    /**
     * Gets pdd
     *
     * @return \DateTime
     */
    public function getPdd()
    {
        return $this->container['pdd'];
    }

    /**
     * Sets pdd
     *
     * @param \DateTime $pdd Planned Delivery Date - плановая дата, начиная с которой отправление может быть доставлено клиенту
     *
     * @return $this
     */
    public function setPdd($pdd)
    {


        /*if (is_null($pdd)) {
            throw new \InvalidArgumentException('non-nullable pdd cannot be null');
        }*/
        $this->container['pdd'] = $pdd;

        return $this;
    }

    /**
     * Gets shipments
     *
     * @return \Ensi\LogisticClient\Dto\CalculationShipment[]
     */
    public function getShipments()
    {
        return $this->container['shipments'];
    }

    /**
     * Sets shipments
     *
     * @param \Ensi\LogisticClient\Dto\CalculationShipment[] $shipments Отправления, которые входят в доставку
     *
     * @return $this
     */
    public function setShipments($shipments)
    {


        /*if (is_null($shipments)) {
            throw new \InvalidArgumentException('non-nullable shipments cannot be null');
        }*/
        $this->container['shipments'] = $shipments;

        return $this;
    }

    /**
     * Gets tariffs
     *
     * @return \Ensi\LogisticClient\Dto\CalculationTariff[]
     */
    public function getTariffs()
    {
        return $this->container['tariffs'];
    }

    /**
     * Sets tariffs
     *
     * @param \Ensi\LogisticClient\Dto\CalculationTariff[] $tariffs Тарифы на доставку
     *
     * @return $this
     */
    public function setTariffs($tariffs)
    {


        /*if (is_null($tariffs)) {
            throw new \InvalidArgumentException('non-nullable tariffs cannot be null');
        }*/
        $this->container['tariffs'] = $tariffs;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


